/*
   STEST.C - Sample program for SAPI.DLL
   Copyright (c) 1996 Sangoma Technologies Inc.
   Author: Glenn Robins
   May 1996

   Use at your own risk.
   Build:
	(Static) runtime library only, plus SAPI.LIB or SAPI32MC.LIB
	Windows 16-bit .EXE, Large Model
	or Win32 GUI

*/

/* for "portability" to Win32 */
#define STRICT

// define MAKEFORNT if building for Win32/WinNT
/*
#define MAKEFORNT
*/

#include <windows.h>
#include <windowsx.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <commdlg.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#ifdef MAKEFORNT
#include "k:\apidev\sapi32mc\sapi32mc.h"
#else
#include "\sapi\sapi.h"
#endif
#include "\sapi\sapi_m.h"


#define SAYRESPONSE(s)	SetDlgItemText(exehwn, 900, s)
#define	SAYSTATE(x)	SetWindowText(exehwn, x)
#define	SAYNOSTATE()	SetWindowText(exehwn, szProgramHeader)

#define	IDM_ABOUT	0x1000

#define STATS_TIMER	3000

HINSTANCE ghinstance;
HWND exehwn;
HWND rxdhwn = NULL;
HWND statshwn = NULL;
DLGPROC dprocrd, dprocst;
SDLC_BLOCK cb;

char txtext[1000];
char rxdetail_text[16384];

// must be packed on 1-byte boundary
typedef struct {
	BYTE station;
	DWORD bps;
	WORD frame_length;
	WORD op_cfg_bits;
	WORD sdlc_cfg_bits;
	WORD exception_bits;
	WORD modem_bits;
	WORD stats_bits;
	WORD slow_poll;
	WORD timeout;
	WORD consec_timeouts;
	WORD max_xid_length;
	WORD bit_times;
	WORD bit_delay_rts;
	WORD wait_for_cts;
} CONFIG_S;

CONFIG_S cfg = { 0, 56000L, 500, 0, 0, 0, 0, 0, 5000, 500, 20, 100, 0, 8, 16 };

char *bits_title[] = { "Miscellaneous Operational Config Bits",
"Miscellaneous SDLC Protocol Config Bits",
"Exception Condition Reporting Bits",
"Modem Configuration Bits",
"Miscellaneous Statistics Format Bits"
};

char *bits_desc[][50] = {
{
"Enable switched CTS/RTS",
"Line idle state is SDLC flags",
"Reserved",
"Reserved",
"Use NRZI encoding",
"Reserved",
"Reserved",
"Reserved",
"Do not pass exceptions automatically",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved"
},{
"Manually issue DISC on RD",
"Manually issue SIM on RIM",
"Do not automatically timeout in NRM",
"Secondary sends DM on SNRM until active",
"Primary automatically sends SNRM on DM",
"Primary automatically sends DISC on FRMR",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved"
},{
"No exception when entering NRM",
"No exception when entering NDM",
"Reserved",
"Reserved",
"No exception on poll timeout",
"No exception on RD while in NRM",
"No exception on DM while in NRM",
"No exception on RIM at primary",
"No exception on XID",
"No exception on TEST",
"No exception on FRMR",
"No exception on SNRM while in NRM",
"Reserved",
"Reserved",
"Reserved",
"No exception on modem error"
},{
"Manual control over DTR and RTS",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved"
},{
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved",
"Reserved"
}
};
WORD bits_to_edit;
WORD bits_num;

char *our_ini_file = "stest.ini";
char *iniHardwareSection = "Hardware";
char *iniCardEntry = "default_card_number";
char *iniAskEntry = "ask_for_card_on_startup";

char *szhigh = "HIGH";
char *szlow = "LOW";
char *szstop = "Stop!";

#ifdef MAKEFORNT
char *abouttitle = "About The STESTer v1.0nt";
char *aboutstatement =
"STEST for NT is Copyright (c) 1996 Sangoma Technologies Inc.\nMay 1996 Release";
#else
char *abouttitle = "About The STESTer v1.0";
char *aboutstatement =
"STEST is Copyright (c) 1996 Sangoma Technologies Inc.\nMay 1996 Release";
#endif
char szProgramHeader[60];
BYTE card = 0;
BYTE askonstartup = 0;

char *szTitleName = "Basic Functions SDLC Tester";

/* prototypes */
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow);
LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam );
LRESULT CALLBACK _export SelCardDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK _export RxDetailDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK _export BitsDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
void DoCommand(void);
BOOL FirstSelCard(void);
BOOL ParseCmdLineForCard(LPSTR lpszCmdLine);
int ParseTextToHex(int l);
void SelCard(void);
void GetConfig(void);
void PutConfig(void);
void UpdateAllStats(void);
BYTE GetAddressByte(WPARAM item);

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow)
{
	MSG msg;
	BOOL fRetVal;
	WNDCLASS wndclass;
	HMENU hmenu;
	char s[120];
	WORD i;

	ghinstance = hInstance;

	// get startup card info
	card = (BYTE)GetPrivateProfileInt(iniHardwareSection, iniCardEntry, 0, our_ini_file);
	askonstartup = (BYTE)GetPrivateProfileInt(iniHardwareSection, iniAskEntry, 0, our_ini_file);

	if (hPrevInstance == NULL) {

		/* set up and register the window class */
		wndclass.style         = CS_HREDRAW | CS_VREDRAW;
		wndclass.lpfnWndProc   = MainWndProc;
		wndclass.cbClsExtra    = 0;
		wndclass.cbWndExtra    = DLGWINDOWEXTRA;
		wndclass.hInstance     = ghinstance;
		wndclass.hIcon         = LoadIcon(ghinstance, "tester");
		wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
		wndclass.hbrBackground = (HBRUSH)GetStockObject(GRAY_BRUSH);
		wndclass.lpszMenuName  = NULL;
		wndclass.lpszClassName = "STEST";

		if (!RegisterClass(&wndclass)) {
			return(0);
		}

	} // end instance check

	exehwn = CreateDialog(ghinstance, "MAINDLG", HWND_DESKTOP, NULL);

	if (!exehwn)  return(0);	/* failed to create window */

	// must tell SAPI to initialize SDLA driver if we are first
	SAPISetup();

	// see if user wants to override startup card
	if (!ParseCmdLineForCard(lpszCmdLine)) {
		if (askonstartup) {
			if (!FirstSelCard()) {
				DestroyWindow(exehwn);
				SAPICleanup();
				return(0);
			}
		}
	}

	// must register for the use of 'card' before we can use it
	if (!SAPIRegisterCard(card)) {
		sprintf(s, "Unable to register card %u!  STEST will now terminate.  (Default card number may be changed by editing STEST.INI.)", card);
		MessageBox(exehwn, s, "STEST FATAL ERROR", MB_OK | MB_ICONHAND);
		DestroyWindow(exehwn);
		SAPICleanup();
		return(0);
	}

	dprocrd = (DLGPROC)MakeProcInstance((FARPROC)RxDetailDlg, ghinstance);

	hmenu = GetSystemMenu(exehwn, FALSE);
	AppendMenu(hmenu, MF_SEPARATOR, 0, (LPSTR) NULL);
	AppendMenu(hmenu, MF_STRING, IDM_ABOUT, "About...");

	sprintf(szProgramHeader, "%s (Card %u)", szTitleName, card);
	SAYNOSTATE();


	// set default values in window
	PutConfig();

	// fill in some arbitrary values in edit fields for fun
	SetDlgItemText(exehwn, 912, "01");
	SetDlgItemText(exehwn, 913, "01");
	SetDlgItemText(exehwn, 500, "1000");
	SetDlgItemText(exehwn, 901, "01 02 03 04 05");

	fRetVal = TRUE;		/* keep looping until FALSE (WM_QUIT) */

	/* stay in this outside loop until the WM_QUIT message has
	been encountered and processed */
	while (fRetVal)  {
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
			if (msg.message == WM_QUIT)
				fRetVal = FALSE;	/* leave main loop */
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		// perform continuous read/write ops if any
		// (this is a real system hog)
	}
	// User wants to quit so clean things up
	if (rxdhwn != NULL)
		DestroyWindow(rxdhwn);
	FreeProcInstance((FARPROC)dprocrd);
	// clean SAPI things up - VERY IMPORTANT!!!
	SAPIDeregisterCard(card);
	SAPICleanup();
	return fRetVal;
}

BOOL ParseCmdLineForCard(LPSTR lpszCmdLine)
{
	int i;
	BYTE c;

	i=0;
	while (lpszCmdLine[i] != NULL && lpszCmdLine[i] != '-') i++;
	if (lpszCmdLine[i] == '-') {
		c = (BYTE)atoi((LPSTR)(lpszCmdLine+i+1));
		if (c < 16) {
			card = c;
			return(TRUE);
		}
	}
	return(FALSE);
}

BOOL FirstSelCard(void)
{
	DLGPROC dproc;
	int i;

	dproc = (DLGPROC)MakeProcInstance((FARPROC)SelCardDlg, ghinstance);
	i=DialogBox(ghinstance, "SELCARD", exehwn, dproc);
	FreeProcInstance((FARPROC)dproc);
	if (i) {
		card = i-1;
		return(TRUE);
	}
	return(FALSE);
}

void SelCard(void)
{
	DLGPROC dproc;
	int i;
//	char s[80];

	dproc = (DLGPROC)MakeProcInstance((FARPROC)SelCardDlg, ghinstance);
	i=DialogBox(ghinstance, "SELCARD", exehwn, dproc);
	FreeProcInstance((FARPROC)dproc);
	if (i) {
		if (SAPIRegisterCard(i-1)) {
			SAPIDeregisterCard(card);
			card = i-1;
			sprintf(szProgramHeader, "%s (Card %u)", szTitleName, card);
			SAYNOSTATE();
		}
		else {
			MessageBox(exehwn, "Unable to register specified card!", "FTEST FATAL ERROR", MB_OK | MB_ICONHAND);
		}
	}
}

/* main window procedure */
LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam )
{
	WORD v;
	char s[10];
	DLGPROC dproc;

	switch(iMessage) {
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case 100:	// Exit button
			DestroyWindow(hWnd);
			PostQuitMessage(0);
			return(0);
		case 101:	// Select card button
			SelCard();
			return(0);
		case 200:	// ENABLE
			cb.command = ENABLE_COMMUNICATIONS;
			cb.buffer_length = 0;
			DoCommand();
			return(0);
		case 201:	// DISABLE
			cb.command = DISABLE_COMMUNICATIONS;
			cb.buffer_length = 0;
			DoCommand();
			return(0);
		case 202:	// READ_MODEM_STATUS
			// do it the command way since it fits into this
			// scheme more easily - it's better to use
			// SAPIGetModemStatus normally
			cb.command = READ_MODEM_STATUS;
			cb.buffer_length = 0;
			DoCommand();
			return(0);
		case 203:	// MODEM CONTROL
			cb.command = SET_MODEM_STATUS;
			cb.buffer_length = 1;
			cb.data[0] = (IsDlgButtonChecked(exehwn, 400)) ? 0x01 : 0x00;
			cb.data[0] |= (IsDlgButtonChecked(exehwn, 401)) ? 0x02 : 0x00;
			DoCommand();
			return(0);
		case 205:	// READ_EXCEPTION_CONDITION
			cb.command = READ_EXCEPTION_CONDITION;
			cb.buffer_length = 0;
			DoCommand();
			return(0);
		case 221:
			if (rxdhwn == NULL) {
				rxdhwn=CreateDialog(ghinstance, "RDETAIL", exehwn, dprocrd);
			}
			return(0);
		case 210:	// READ
			cb.command = SDLC_READ;
			cb.buffer_length = 0;
			cb.sdlc_address = GetAddressByte(913);
			DoCommand();
			return(0);
		case 211:	// WRITE
			cb.command = SDLC_WRITE;
			v = GetDlgItemText(exehwn, 901, txtext, 1000);
			v = ParseTextToHex(v);
			cb.buffer_length = v;
			cb.PF_bit = (IsDlgButtonChecked(exehwn, 920)) ? 1 : 0;
			cb.sdlc_address = GetAddressByte(912);
			DoCommand();
			return(0);
		case 230:	// SET CONFIGURATION
			cb.command = SET_SDLC_CONFIGURATION;
			cb.buffer_length = 0x1f;
			GetConfig();
			memcpy(cb.data, &cfg.station, 0x1f);
			DoCommand();
			return(0);
		case 410:
			cb.command = ADD_STATION;
			cb.sdlc_address = GetAddressByte(912);
			cb.poll_interval = (WORD)GetDlgItemInt(exehwn, 500, NULL, FALSE);
			cb.buffer_length = 0;
			DoCommand();
			return(0);
		case 411:
			cb.command = ACTIVATE_STATION;
			cb.sdlc_address = GetAddressByte(912);
			cb.buffer_length = 0;
			DoCommand();
			return(0);
		case 412:
			cb.command = LIST_STATIONS_IN_NRM;
			cb.buffer_length = 0;
			DoCommand();
			return(0);
		case 240:
		case 241:
		case 242:
		case 243:
		case 244:
			bits_num = GET_WM_COMMAND_ID(wParam, lParam) - 240;
			bits_to_edit = *(WORD *)(&cfg.op_cfg_bits + bits_num);
			dproc = (DLGPROC)MakeProcInstance((FARPROC)BitsDlg, ghinstance);
			DialogBox(ghinstance, "BITSDIALOG", exehwn, dproc);
			FreeProcInstance((FARPROC)dproc);
			*(WORD *)(&cfg.op_cfg_bits + bits_num) = bits_to_edit;
			sprintf(s, "%04X", bits_to_edit);
			SetDlgItemText(exehwn, 340+bits_num, s);
			return(0);

		}
		break;

	case WM_SYSCOMMAND:
		if (wParam == SC_CLOSE) {
			DestroyWindow(hWnd);
			PostQuitMessage(0);
			return(0);
		}
		if (GET_WM_COMMAND_ID(wParam, lParam) == IDM_ABOUT) {
			MessageBox(exehwn, aboutstatement, abouttitle, MB_OK | MB_ICONINFORMATION);
			return(0);
		}
		break;
	}
	return DefDlgProc( hWnd, iMessage, wParam, lParam );
}

/*
	Performs command in SDLC_BLOCK cb, and displays return codes and
	specific return info if any
*/
void DoCommand(void)
{
	char s[150], s1[150], t[10];
	WORD i, n;

	SAPIControl(&cb, card);
	sprintf(s, "Return code: 0x%02X - ", (BYTE)cb.return_code);
	switch(cb.return_code) {
	case 0x00:
		switch(cb.command) {
		case READ_MODEM_STATUS:
			sprintf(s1, "CTS is %s and DCD is %s", (cb.data[0] & 0x20) ? szhigh : szlow, (cb.data[0] & 0x08) ? szhigh : szlow);
			strcat(s, s1);
			break;
		case SDLC_READ:
			sprintf(s1, "%u bytes (PF=%u,Addr=%02X): ", cb.buffer_length, cb.PF_bit, cb.sdlc_address);
			strcat(s, s1);
			for (i=0; i < cb.buffer_length; i++) {
				if (i > 11) {
					strcat(s, "...");
					break;
				}
				sprintf(s1, "%02X ", (BYTE)cb.data[i]);
				strcat(s, s1);
			}
			if (rxdhwn != NULL) {
				rxdetail_text[0] = 0;
				s1[0] = 0;
				for (n=0; n < cb.buffer_length; n++) {
					if ((n%16) == 0) {
						if (n > 0) {
							// add the line
							strcat(s1, "\r\n");
							strcat(rxdetail_text, s1);
							strcpy(s1, "");
						}
						sprintf(t, "%04X  ", n);
						strcat(s1, t);
					}
					sprintf(t, "%02X ", (BYTE)cb.data[n]);
					strcat(s1, t);
					if (((n+1)%8) == 0 && ((n+1)%16) != 0)
						strcat(s1, "- ");
				}
				// add the last line
				strcat(s1, "\r\n");
				strcat(rxdetail_text, s1);
				SetDlgItemText(rxdhwn, 103, rxdetail_text);
				SetDlgItemInt(rxdhwn, 105, cb.buffer_length, FALSE);
			}

			break;
		case LIST_STATIONS_IN_NRM:
			sprintf(s1, "NRM (Count=%u): ", cb.buffer_length);
			strcat(s, s1);
			for (i=0; i < cb.buffer_length; i++) {
				if (i > 12) {
					strcat(s, "...");
					break;
				}
				sprintf(s1, "%02X ", (BYTE)cb.data[i]);
				strcat(s, s1);
			}

			break;
		default:
			strcat(s, "The action was performed successfully");

		}
		break;
	case 0x0a:
		strcat(s, "Hardware timeout error");
		break;
	case 0x20:
		strcat(s, "One or more stations have changed state");
		break;
	case 0x21:
		strcat(s, "Timeout while in NRM");
		break;
	case 0x22:
		strcat(s, "RD received while in NRM");
		break;
	case 0x23:
		strcat(s, "DM received while in NRM");
		break;
	case 0x24:
		strcat(s, "SNRM received while in NRM");
		break;
	case 0x25:
		strcat(s, "RIM was received");
		break;
	case 0x26:
		sprintf(s1, "XID was received of length %u", cb.buffer_length);
		strcat(s, s1);
		break;
	case 0x27:
		sprintf(s1, "TEST was received of length %u", cb.buffer_length);
		strcat(s, s1);
		break;
	case 0x28:
		strcat(s, "FRMR transmitted or received");
		break;
	case 0x30:
		strcat(s, "Change in modem status occurred");
		break;
	default:
		// Command not successful messages
		// If no particular return code is checked, it means that
		// there is only one left after checking above - it's not
		// very portable in the event that another return code is
		// added, but we'll need another STEST in that case anyway.
		switch(cb.command) {
		case SET_SDLC_CONFIGURATION:
			sprintf(s1, "Configuration data invalid at offset %XH", cb.buffer_length);
			strcat(s, s1);
			break;
		case ENABLE_COMMUNICATIONS:
			strcat(s, "Configuration not set");
			break;
		case ADD_STATION:
			switch(cb.return_code) {
			case 0x01:
				strcat(s, "Configuration not set");
				break;
			case 0x02:
				strcat(s, "Invalid SDLC address");
				break;
			case 0x03:
				strcat(s, "The station has already been added");
				break;
			case 0x04:
				strcat(s, "Invalid poll interval");
				break;
			}
			break;
		case ACTIVATE_STATION:
			switch(cb.return_code) {
			case 0x03:
				strcat(s, "The station has not been added");
				break;
			case 0x04:
				strcat(s, "Station already active");
				break;
			}
			break;

		case SDLC_READ:
			switch(cb.return_code) {
			case 0x05:
				strcat(s, "No frames available for reception");
				break;
			case 0x01:
				strcat(s, "Receiver has not been enabled");
				break;
			case 0x02:
				strcat(s, "Invalid SDLC address");
				break;
			case 0x03:
				strcat(s, "Station not added");
				break;
			case 0x04:
				strcat(s, "Station in disconnected mode");
				break;
			}
			break;
		case SDLC_WRITE:
			switch(cb.return_code) {
			case 0x05:
				strcat(s, "Invalid frame length");
				break;
			case 0x01:
				strcat(s, "Communications has not been enabled");
				break;
			case 0x02:
				strcat(s, "Invalid SDLC address");
				break;
			case 0x03:
				strcat(s, "Station not added");
				break;
			case 0x04:
				strcat(s, "Station in disconnected mode");
				break;
			case 0x06:
				strcat(s, "Transmit window closed or no buffers");
				break;
			}
			break;
		}
	}
	SAYRESPONSE(s);
}

LRESULT CALLBACK _export SelCardDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	int n, m, default_card;
	LRESULT c;
	char s[5];
	static int ncard;

	switch(iMessage) {
	case WM_SYSCOMMAND:
		switch(wParam & 0xfff0) {
		case SC_CLOSE:	/* Don't allow user to close window this way */
			return(1);
		}
		break;
	case WM_INITDIALOG:
		c = SAPIGetCards(); m = 0;
		ncard = (int)card;
		for (n=0; n < 16; n++) {
			if (c & (1L << (16+n))) {
				sprintf(s, "%2d", n);
				SendDlgItemMessage(hDlg, 101, CB_ADDSTRING, 0, (LPARAM)s);
				if (ncard == n)
					SendDlgItemMessage(hDlg, 101, CB_SETCURSEL, m, 0);
				m++;
			}
		}
		default_card = GetPrivateProfileInt(iniHardwareSection, iniCardEntry, 0, our_ini_file);
		sprintf(s, "%u", (UINT)default_card);
		SetDlgItemText(hDlg, 103, s);
		CheckDlgButton(hDlg, 104, askonstartup);
		return(1L);
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case 101:
			if (GET_WM_COMMAND_CMD(wParam, lParam) == CBN_SELENDOK) {
				SendDlgItemMessage(hDlg, 101, CB_GETLBTEXT, (WPARAM)SendDlgItemMessage(hDlg, 101, CB_GETCURSEL, 0, 0), (LPARAM)s);
				ncard = atoi(s);
			}
			break;
		case IDOK:
			if (IsDlgButtonChecked(hDlg, 102)) {
				sprintf(s, "%u", (UINT)ncard);
				WritePrivateProfileString(iniHardwareSection, iniCardEntry, s, our_ini_file);
			}
			if (IsDlgButtonChecked(hDlg, 104)) strcpy(s, "1");
			else strcpy(s, "0");
			if (askonstartup != (s[0]-'0'))  {
				WritePrivateProfileString(iniHardwareSection, iniAskEntry, s, our_ini_file);
				askonstartup = (s[0]-'0');
			}
			EndDialog(hDlg, ncard+1);
			break;
		case IDCANCEL:
			EndDialog(hDlg, 0);
			break;
		}
	}
	return(0);
}

int ParseTextToHex(int l)
{
	int i, j;
	WORD v;

	i=0; j=0;
	while (i < l) {
		sscanf(&txtext[i], "%2x", &v);
		cb.data[j] = (BYTE)v;
		j++;
		while (i < l && txtext[i] != ' ') i++;
		i++;
	}
	return(j);
}

/*
	Gets configuration settings as set in dialog box and updates
	data in memory
*/
void GetConfig(void)
{
	cfg.station = (IsDlgButtonChecked(exehwn, 810)) ? 1 : 0;
	cfg.bps = (DWORD)GetDlgItemInt(exehwn, 800, NULL, FALSE) * 1000UL;
	cfg.frame_length = (WORD)GetDlgItemInt(exehwn, 801, NULL, FALSE);
	cfg.max_xid_length = (WORD)GetDlgItemInt(exehwn, 802, NULL, FALSE);
	cfg.slow_poll = (WORD)GetDlgItemInt(exehwn, 808, NULL, FALSE);
	cfg.timeout = (WORD)GetDlgItemInt(exehwn, 807, NULL, FALSE);
	cfg.consec_timeouts = (WORD)GetDlgItemInt(exehwn, 806, NULL, FALSE);
	cfg.bit_times = (WORD)GetDlgItemInt(exehwn, 803, NULL, FALSE);
	cfg.bit_delay_rts = (WORD)GetDlgItemInt(exehwn, 804, NULL, FALSE);
	cfg.wait_for_cts = (WORD)GetDlgItemInt(exehwn, 805, NULL, FALSE);
}

/*
	Fills in dialog box with configuration settings in memory
*/
void PutConfig(void)
{
	WORD i;
	char s[10];

	CheckDlgButton(exehwn, 810, (cfg.station) ? 1 : 0);
	SetDlgItemInt(exehwn, 800, (WORD)(cfg.bps / 1000UL), FALSE);
	SetDlgItemInt(exehwn, 801, cfg.frame_length, FALSE);
	SetDlgItemInt(exehwn, 802, cfg.max_xid_length, FALSE);
	SetDlgItemInt(exehwn, 808, cfg.slow_poll, FALSE);
	SetDlgItemInt(exehwn, 807, cfg.timeout, FALSE);
	SetDlgItemInt(exehwn, 806, cfg.consec_timeouts, FALSE);
	SetDlgItemInt(exehwn, 803, cfg.bit_times, FALSE);
	SetDlgItemInt(exehwn, 804, cfg.bit_delay_rts, FALSE);
	SetDlgItemInt(exehwn, 805, cfg.wait_for_cts, FALSE);
	for (i=0; i < 5; i++) {
		sprintf(s, "%04X", *(WORD *)(&cfg.op_cfg_bits + i));
		SetDlgItemText(exehwn, 340+i, s);
	}
}


LRESULT CALLBACK _export RxDetailDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{

	switch(iMessage) {
	case WM_SYSCOMMAND:
		switch(wParam & 0xfff0) {
		case SC_CLOSE:	/* Don't allow user to close window this way */
			return(1);
		}
		break;
	case WM_INITDIALOG:
		return(1L);
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case 102:
			EndDialog(hDlg, 0);
			rxdhwn = NULL;
			break;
		}
	}
	return(0);
}


BYTE GetAddressByte(WPARAM item)
{
	WORD v;
	char s[10];

	GetDlgItemText(exehwn, item, s, 9);
	sscanf(s, "%x", &v);
	return((BYTE)v);
}

LRESULT CALLBACK _export BitsDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	WORD i;

	switch(iMessage) {
	case WM_SYSCOMMAND:
		switch(wParam & 0xfff0) {
		case SC_CLOSE:	/* Don't allow user to close window this way */
			return(1);
		}
		break;
	case WM_INITDIALOG:
		SetWindowText(hDlg, bits_title[bits_num]);
		for (i=0; i < 16; i++) {
			SetDlgItemText(hDlg, 200+i, bits_desc[bits_num][i]);
			CheckDlgButton(hDlg, 200+i, (bits_to_edit & (0x01 << i)) ? 1 : 0);
		}
		return(1L);
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case IDOK:
			bits_to_edit = 0;
			for (i=0; i < 16; i++)
				bits_to_edit |= (IsDlgButtonChecked(hDlg, 200+i)) ? (0x01 << i) : 0;
			EndDialog(hDlg, 0);
			break;
		}
	}
	return(0);
}

